![Candor](assets/candor_black.png#gh-light-mode-only)
![Candor](assets/candor_white.png#gh-dark-mode-only)


> **🚀 A mimimalistic containerized Continuous Integration ecosystem.**

# Features
- [🌊] Minimalistic from the ground up. Who says powerful can't be beautiful?
- [🖇️] One dashboard, as many runners as you want. 
- [🐳] Containerization with Docker at its core. Say goodbye to conflicting PATHs and dependencies.
- [🗄️] Artifact archiving to S3 storage.
- [🎨] Fast, responsive, modern design. Every piece of information is hand-selected and placed with purpose.
- [🖥️] Management performed through an elegant CLI, day-to-day business served through the web.

Convinced already? [Click me to get started]().

# Showcase

![Homepage](assets/showcase_home.png)

> 🏠 The home page contains an overview of all pipelines.

![Pipeline](assets/showcase_pipeline.png)

> 🛠️ A single pipeline can be inspected, modified and run.

![CLI](assets/showcase_cli.png)

> 📝 CRUD operations are performed through the interactive CLI.

# Installation & Documentation

Almost all documentation can be found in the [wiki](https://github.com/Arraying/Candor/wiki). If something is not covered in the wiki, feel free to [submit an issue](https://github.com/Arraying/Candor/issues/new) with your question.

Quick links:
- [Installation guide](https://github.com/Arraying/Candor/wiki/Installation).
- [Understanding the basic concepts](https://github.com/Arraying/Candor/wiki/Concepts).
- [Configuring dashboard and runners](https://github.com/Arraying/Candor/wiki/Configuration).
- [Hands-on first pipeline](https://github.com/Arraying/Candor/wiki/Pipelines-101).
- [API reference](https://github.com/Arraying/Candor/wiki/API).

# Roadmap

The current development roadmap is as follows:
- [⭐] Quality of life improvements to the config editor.
- [🐙] A GitHub status integration.
- [💾] The ability to use state of previous pipelines as base images.
- [🔌] A plugin system such that common pipeline steps such as Git clones can be abbreviated.
- [🔧] A fully-fledged web dashboard replacing the CLI.
- [📡] Updates and logs in real time.

Please note that this roadmap will most likely change as priorities shift or new ideas arise.

# Contributing

Contributors are awesome!
Many contribution types are accepted, from feature implementations to bug bug reports/fixes, or even discussing the state of the codebase.

## Contribution Flow

1. All contributions should start off as an issue.
Then, if necessary, the proposed contribution will be discussed.
2. For code contributions, please fork the project's `main` branch, since this is where everything comes together.
3. If your contributions are testable within reason (the final judgement of this is up to the maintainers), please write or edit some tests.
All tests must pass before the contribution can be accepted, and there must not be any linter errors or warnings.
4. If applicable, create a pull-request, where your contribution will be reviewed.
5. Propose any changes to documentation in the wiki or even pull-request itself. 
6. Once the pull-request or change is accepted, the issue will be closed, and you are officially a contributor!

## Further Notes

When contributing, please keep the following in mind:
- Bug reports should be descriptive and reproducible, the more information the better (including version)!
- Follow the preexisting coding style of the project.
Indent using spaces, not tabs.
- Embrace documentation! 
Not only will users be able to understand how to use the software, it also explains it to other developers and yourself later down the road.
- By contributing code, you agree to release your code under the same license as the project.


# Attribution

The favicon was designed by [OpenMoji](https://openmoji.org/) – the open-source emoji and icon project. It is licensed under the [CC BY-SA 4.0](https://creativecommons.org/licenses/by-sa/4.0/#) license.

# License

Copyright (c) 2022 Paul Huebner

Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the "Software"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.
